Index: drivers/video/aty/atyfb_base.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/aty/atyfb_base.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/aty/atyfb_base.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/aty/atyfb_base.c	4 Aug 2004 01:29:59 -0000	1.2
@@ -2498,54 +2986,54 @@
     struct fb_info_aty *info;
 
     for (m64_num = 0; m64_num < mach64_count; m64_num++) {
-	if (!phys_vmembase[m64_num] || !phys_size[m64_num] ||
-	    !phys_guiregbase[m64_num]) {
-	    printk(" phys_*[%d] parameters not set => returning early. \n",
-		   m64_num);
-	    continue;
-	}
-
-	info = kmalloc(sizeof(struct fb_info_aty), GFP_ATOMIC);
-	if (!info) {
-	    printk("atyfb_init: can't alloc fb_info_aty\n");
-	    return -ENOMEM;
-	}
-	memset(info, 0, sizeof(struct fb_info_aty));
-
-	/*
-	 *  Map the video memory (physical address given) to somewhere in the
-	 *  kernel address space.
-	 */
-	info->frame_buffer = (unsigned long)ioremap(phys_vmembase[m64_num],
+        if (!phys_vmembase[m64_num] || !phys_size[m64_num] ||
+            !phys_guiregbase[m64_num]) {
+            printk(" phys_*[%d] parameters not set => returning early. \n",
+                   m64_num);
+            continue;
+        }
+
+        info = kmalloc(sizeof(struct fb_info_aty), GFP_ATOMIC);
+        if (!info) {
+            printk("atyfb_init: can't alloc fb_info_aty\n");
+            return -ENOMEM;
+        }
+        memset(info, 0, sizeof(struct fb_info_aty));
+
+        /*
+         *  Map the video memory (physical address given) to somewhere in the
+         *  kernel address space.
+         */
+        info->frame_buffer = (unsigned long)ioremap(phys_vmembase[m64_num],
 						    phys_size[m64_num]);
-	info->frame_buffer_phys = info->frame_buffer;  /* Fake! */
-	info->ati_regbase = (unsigned long)ioremap(phys_guiregbase[m64_num],
+        info->frame_buffer_phys = info->frame_buffer;  /* Fake! */
+        info->ati_regbase = (unsigned long)ioremap(phys_guiregbase[m64_num],
 						   0x10000)+0xFC00ul;
-	info->ati_regbase_phys = info->ati_regbase;  /* Fake! */
+        info->ati_regbase_phys = info->ati_regbase;  /* Fake! */
 
-	aty_st_le32(CLOCK_CNTL, 0x12345678, info);
-	clock_r = aty_ld_le32(CLOCK_CNTL, info);
+        aty_st_le32(CLOCK_CNTL, 0x12345678, info);
+        clock_r = aty_ld_le32(CLOCK_CNTL, info);
 
-	switch (clock_r & 0x003F) {
-	    case 0x12:
-		info->clk_wr_offset = 3;  /*  */
-		break;
-	    case 0x34:
-		info->clk_wr_offset = 2;  /* Medusa ST-IO ISA Adapter etc. */
-		break;
-	    case 0x16:
-		info->clk_wr_offset = 1;  /*  */
-		break;
-	    case 0x38:
-		info->clk_wr_offset = 0;  /* Panther 1 ISA Adapter (Gerald) */
-		break;
-	}
-
-	if (!aty_init(info, "ISA bus")) {
-	    kfree(info);
-	    /* This is insufficient! kernel_map has added two large chunks!! */
-	    return -ENXIO;
-	}
+        switch (clock_r & 0x003F) {
+            case 0x12:
+                info->clk_wr_offset = 3;  /*  */
+                break;
+            case 0x34:
+                info->clk_wr_offset = 2;  /* Medusa ST-IO ISA Adapter etc. */
+                break;
+            case 0x16:
+                info->clk_wr_offset = 1;  /*  */
+                break;
+            case 0x38:
+                info->clk_wr_offset = 0;  /* Panther 1 ISA Adapter (Gerald) */
+                break;
+        }
+
+        if (!aty_init(info, "ISA bus")) {
+            kfree(info);
+            /* This is insufficient! kernel_map has added two large chunks!! */
+            return -ENXIO;
+        }
     }
 #endif /* CONFIG_ATARI */
     return 0;
@@ -2557,69 +3045,71 @@
     char *this_opt;
 
     if (!options || !*options)
-	return 0;
+        return 0;
 
     while ((this_opt = strsep(&options, ",")) != NULL) {
-	if (!strncmp(this_opt, "font:", 5)) {
-		char *p;
-		int i;
-
-		p = this_opt + 5;
-		for (i = 0; i < sizeof(fontname) - 1; i++)
-			if (!*p || *p == ' ' || *p == ',')
-				break;
-		memcpy(fontname, this_opt + 5, i);
-		fontname[i] = 0;
-	} else if (!strncmp(this_opt, "noblink", 7)) {
-		curblink = 0;
-	} else if (!strncmp(this_opt, "noaccel", 7)) {
-		noaccel = 1;
-	} else if (!strncmp(this_opt, "vram:", 5))
-		default_vram = simple_strtoul(this_opt+5, NULL, 0);
-	else if (!strncmp(this_opt, "pll:", 4))
-		default_pll = simple_strtoul(this_opt+4, NULL, 0);
-	else if (!strncmp(this_opt, "mclk:", 5))
-		default_mclk = simple_strtoul(this_opt+5, NULL, 0);
+        if (!strncmp(this_opt, "font:", 5)) {
+                char *p;
+                int i;
+
+                p = this_opt + 5;
+                for (i = 0; i < sizeof(fontname) - 1; i++)
+                        if (!*p || *p == ' ' || *p == ',')
+                                break;
+                memcpy(fontname, this_opt + 5, i);
+                fontname[i] = 0;
+        } else if (!strncmp(this_opt, "noblink", 7)) {
+                curblink = 0;
+        } else if (!strncmp(this_opt, "noaccel", 7)) {
+                noaccel = 1;
+        } else if (!strncmp(this_opt, "vram:", 5))
+                default_vram = simple_strtoul(this_opt+5, NULL, 0);
+        else if (!strncmp(this_opt, "pll:", 4))
+                default_pll = simple_strtoul(this_opt+4, NULL, 0);
+        else if (!strncmp(this_opt, "mclk:", 5))
+                default_mclk = simple_strtoul(this_opt+5, NULL, 0);
+        else if (!strncmp(this_opt, "xclk:", 5))
+                default_xclk = simple_strtoul(this_opt+5, NULL, 0);
 #ifdef CONFIG_PPC
-	else if (!strncmp(this_opt, "vmode:", 6)) {
-	    unsigned int vmode = simple_strtoul(this_opt+6, NULL, 0);
-	    if (vmode > 0 && vmode <= VMODE_MAX)
-		default_vmode = vmode;
-	} else if (!strncmp(this_opt, "cmode:", 6)) {
-	    unsigned int cmode = simple_strtoul(this_opt+6, NULL, 0);
-	    switch (cmode) {
-		case 0:
-		case 8:
-		    default_cmode = CMODE_8;
-		    break;
-		case 15:
-		case 16:
-		    default_cmode = CMODE_16;
-		    break;
-		case 24:
-		case 32:
-		    default_cmode = CMODE_32;
-		    break;
-	    }
-	}
+        else if (!strncmp(this_opt, "vmode:", 6)) {
+            unsigned int vmode = simple_strtoul(this_opt+6, NULL, 0);
+            if (vmode > 0 && vmode <= VMODE_MAX)
+                default_vmode = vmode;
+        } else if (!strncmp(this_opt, "cmode:", 6)) {
+            unsigned int cmode = simple_strtoul(this_opt+6, NULL, 0);
+            switch (cmode) {
+                case 0:
+                case 8:
+                    default_cmode = CMODE_8;
+                    break;
+                case 15:
+                case 16:
+                    default_cmode = CMODE_16;
+                    break;
+                case 24:
+                case 32:
+                    default_cmode = CMODE_32;
+                    break;
+            }
+        }
 #endif
 #ifdef CONFIG_ATARI
-	/*
-	 * Why do we need this silly Mach64 argument?
-	 * We are already here because of mach64= so its redundant.
-	 */
-	else if (MACH_IS_ATARI && (!strncmp(this_opt, "Mach64:", 7))) {
-	    static unsigned char m64_num;
-	    static char mach64_str[80];
-	    strncpy(mach64_str, this_opt+7, 80);
-	    if (!store_video_par(mach64_str, m64_num)) {
-		m64_num++;
-		mach64_count = m64_num;
-	    }
-	}
+        /*
+         * Why do we need this silly Mach64 argument?
+         * We are already here because of mach64= so its redundant.
+         */
+        else if (MACH_IS_ATARI && (!strncmp(this_opt, "Mach64:", 7))) {
+            static unsigned char m64_num;
+            static char mach64_str[80];
+            strncpy(mach64_str, this_opt+7, 80);
+            if (!store_video_par(mach64_str, m64_num)) {
+                m64_num++;
+                mach64_count = m64_num;
+            }
+        }
 #endif
-	else
-	    mode_option = this_opt;
+        else
+            mode_option = this_opt;
     }
     return 0;
 }
@@ -2634,20 +3124,20 @@
     printk("store_video_par() '%s' \n", video_str);
 
     if (!(p = strtoke(video_str, ";")) || !*p)
-	goto mach64_invalid;
+        goto mach64_invalid;
     vmembase = simple_strtoul(p, NULL, 0);
     if (!(p = strtoke(NULL, ";")) || !*p)
-	goto mach64_invalid;
+        goto mach64_invalid;
     size = simple_strtoul(p, NULL, 0);
     if (!(p = strtoke(NULL, ";")) || !*p)
-	goto mach64_invalid;
+        goto mach64_invalid;
     guiregbase = simple_strtoul(p, NULL, 0);
 
     phys_vmembase[m64_num] = vmembase;
     phys_size[m64_num] = size;
     phys_guiregbase[m64_num] = guiregbase;
     printk(" stored them all: $%08lX $%08lX $%08lX \n", vmembase, size,
-	   guiregbase);
+           guiregbase);
     return 0;
 
 mach64_invalid:
@@ -2662,14 +3152,14 @@
 
     sbegin  = s ? s : ssave;
     if (!sbegin)
-	return NULL;
+        return NULL;
     if (*sbegin == '\0') {
-	ssave = NULL;
-	return NULL;
+        ssave = NULL;
+        return NULL;
     }
     send = strpbrk(sbegin, ct);
     if (send && *send != '\0')
-	*send++ = '\0';
+        *send++ = '\0';
     ssave = send;
     return sbegin;
 }
@@ -2679,24 +3169,27 @@
 {
     struct fb_info_aty *info = (struct fb_info_aty *)fb;
     struct atyfb_par par;
+    u32 monitors_enabled;
 
     /* Do we have to save the colormap? */
     if (fb_display[currcon].cmap.len)
-	fb_get_cmap(&fb_display[currcon].cmap, 1, atyfb_getcolreg, fb);
+        fb_get_cmap(&fb_display[currcon].cmap, 1, atyfb_getcolreg, fb);
 
 #ifdef CONFIG_FB_ATY_CT
     /* Erase HW Cursor */
     if (info->cursor)
-	atyfb_cursor(&fb_display[currcon], CM_ERASE,
-		     info->cursor->pos.x, info->cursor->pos.y);
+        atyfb_cursor(&fb_display[currcon], CM_ERASE,
+                     info->cursor->pos.x, info->cursor->pos.y);
 #endif /* CONFIG_FB_ATY_CT */
 
     currcon = con;
 
-    atyfb_decode_var(&fb_display[con].var, &par, info);
+    monitors_enabled = atyfb_monitors_enabled(info);
+
+    atyfb_decode_var(&fb_display[con].var, &par, info, monitors_enabled);
     atyfb_set_par(&par, info);
     atyfb_set_dispsw(&fb_display[con], info, par.crtc.bpp,
-		     par.accel_flags & FB_ACCELF_TEXT);
+                     par.accel_flags & FB_ACCELF_TEXT);
 
     /* Install new colormap */
     do_install_cmap(con, fb);
@@ -2704,8 +3197,8 @@
 #ifdef CONFIG_FB_ATY_CT
     /* Install hw cursor */
     if (info->cursor) {
-	aty_set_cursor_color(info);
-	aty_set_cursor_shape(info);
+        aty_set_cursor_color(info);
+        aty_set_cursor_shape(info);
     }
 #endif /* CONFIG_FB_ATY_CT */
     return 1;
@@ -2722,32 +3215,32 @@
 
 #ifdef CONFIG_PMAC_BACKLIGHT
     if ((_machine == _MACH_Pmac) && blank)
-    	set_backlight_enable(0);
+        set_backlight_enable(0);
 #endif /* CONFIG_PMAC_BACKLIGHT */
 
     gen_cntl = aty_ld_8(CRTC_GEN_CNTL, info);
     if (blank > 0)
-	switch (blank-1) {
-	    case VESA_NO_BLANKING:
-		gen_cntl |= 0x40;
-		break;
-	    case VESA_VSYNC_SUSPEND:
-		gen_cntl |= 0x8;
-		break;
-	    case VESA_HSYNC_SUSPEND:
-		gen_cntl |= 0x4;
-		break;
-	    case VESA_POWERDOWN:
-		gen_cntl |= 0x4c;
-		break;
-	}
+        switch (blank-1) {
+            case VESA_NO_BLANKING:
+                gen_cntl |= 0x40;
+                break;
+            case VESA_VSYNC_SUSPEND:
+                gen_cntl |= 0x8;
+                break;
+            case VESA_HSYNC_SUSPEND:
+                gen_cntl |= 0x4;
+                break;
+            case VESA_POWERDOWN:
+                gen_cntl |= 0x4c;
+                break;
+        }
     else
-	gen_cntl &= ~(0x4c);
+        gen_cntl &= ~(0x4c);
     aty_st_8(CRTC_GEN_CNTL, gen_cntl, info);
 
 #ifdef CONFIG_PMAC_BACKLIGHT
     if ((_machine == _MACH_Pmac) && !blank)
-    	set_backlight_enable(1);
+        set_backlight_enable(1);
 #endif /* CONFIG_PMAC_BACKLIGHT */
 }
 
@@ -2758,12 +3251,12 @@
      */
 
 static int atyfb_getcolreg(u_int regno, u_int *red, u_int *green, u_int *blue,
-			   u_int *transp, struct fb_info *fb)
+                           u_int *transp, struct fb_info *fb)
 {
     struct fb_info_aty *info = (struct fb_info_aty *)fb;
 
     if (regno > 255)
-	return 1;
+        return 1;
     *red = (info->palette[regno].red<<8) | info->palette[regno].red;
     *green = (info->palette[regno].green<<8) | info->palette[regno].green;
     *blue = (info->palette[regno].blue<<8) | info->palette[regno].blue;
@@ -2779,13 +3272,13 @@
      */
 
 static int atyfb_setcolreg(u_int regno, u_int red, u_int green, u_int blue,
-			   u_int transp, struct fb_info *fb)
+                           u_int transp, struct fb_info *fb)
 {
     struct fb_info_aty *info = (struct fb_info_aty *)fb;
     int i, scale;
 
     if (regno > 255)
-	return 1;
+        return 1;
     red >>= 8;
     green >>= 8;
     blue >>= 8;
@@ -2794,42 +3287,35 @@
     info->palette[regno].blue = blue;
     i = aty_ld_8(DAC_CNTL, info) & 0xfc;
     if (M64_HAS(EXTRA_BRIGHT))
-	i |= 0x2;	/*DAC_CNTL|0x2 turns off the extra brightness for gt*/
+        i |= 0x2;       /*DAC_CNTL|0x2 turns off the extra brightness for gt*/
     aty_st_8(DAC_CNTL, i, info);
     aty_st_8(DAC_MASK, 0xff, info);
     scale = (M64_HAS(INTEGRATED) && info->current_par.crtc.bpp == 16) ? 3 : 0;
-#ifdef CONFIG_ATARI
-    out_8(&info->aty_cmap_regs->windex, regno << scale);
-    out_8(&info->aty_cmap_regs->lut, red);
-    out_8(&info->aty_cmap_regs->lut, green);
-    out_8(&info->aty_cmap_regs->lut, blue);
-#else
     writeb(regno << scale, &info->aty_cmap_regs->windex);
     writeb(red, &info->aty_cmap_regs->lut);
     writeb(green, &info->aty_cmap_regs->lut);
     writeb(blue, &info->aty_cmap_regs->lut);
-#endif
     if (regno < 16)
-	switch (info->current_par.crtc.bpp) {
+        switch (info->current_par.crtc.bpp) {
 #ifdef FBCON_HAS_CFB16
-	    case 16:
-		info->fbcon_cmap.cfb16[regno] = (regno << 10) | (regno << 5) |
-						regno;
-		break;
+            case 16:
+                info->fbcon_cmap.cfb16[regno] = (regno << 10) | (regno << 5) |
+                                                regno;
+                break;
 #endif
 #ifdef FBCON_HAS_CFB24
-	    case 24:
-		info->fbcon_cmap.cfb24[regno] = (regno << 16) | (regno << 8) |
-						regno;
-		break;
+            case 24:
+                info->fbcon_cmap.cfb24[regno] = (regno << 16) | (regno << 8) |
+                                                regno;
+                break;
 #endif
 #ifdef FBCON_HAS_CFB32
-	    case 32:
-		i = (regno << 8) | regno;
-		info->fbcon_cmap.cfb32[regno] = (i << 16) | i;
-		break;
+            case 32:
+                i = (regno << 8) | regno;
+                info->fbcon_cmap.cfb32[regno] = (i << 16) | i;
+                break;
 #endif
-	    }
+            }
     return 0;
 }
 
@@ -2837,12 +3323,12 @@
 static void do_install_cmap(int con, struct fb_info *info)
 {
     if (con != currcon)
-	return;
+        return;
     if (fb_display[con].cmap.len)
-	fb_set_cmap(&fb_display[con].cmap, 1, atyfb_setcolreg, info);
+        fb_set_cmap(&fb_display[con].cmap, 1, atyfb_setcolreg, info);
     else {
-	int size = fb_display[con].var.bits_per_pixel == 16 ? 32 : 256;
-	fb_set_cmap(fb_default_cmap(size), 1, atyfb_setcolreg, info);
+        int size = fb_display[con].var.bits_per_pixel == 16 ? 32 : 256;
+        fb_set_cmap(fb_default_cmap(size), 1, atyfb_setcolreg, info);
     }
 }
 
@@ -2866,27 +3352,27 @@
     height = yres - conp->vc_rows * fontheight(p);
 
     if (height && (yoffset + yres > sy)) {
-	u32 xres, xoffset;
-	u32 bgx;
-
-	xres = (((par->crtc.h_tot_disp >> 16) & 0xff) + 1) * 8;
-	xoffset = fb_display[con].var.xoffset;
+        u32 xres, xoffset;
+        u32 bgx;
 
+        xres = (((par->crtc.h_tot_disp >> 16) & 0xff) + 1) * 8;
+        xoffset = fb_display[con].var.xoffset;
 
-	bgx = attr_bgcol_ec(p, conp);
-	bgx |= (bgx << 8);
-	bgx |= (bgx << 16);
 
-	if (sy + height > par->crtc.vyres) {
-	    wait_for_fifo(1, info);
-	    aty_st_le32(SC_BOTTOM, sy + height - 1, info);
-	}
-	aty_rectfill(xoffset, sy, xres, height, bgx, info);
+        bgx = attr_bgcol_ec(p, conp);
+        bgx |= (bgx << 8);
+        bgx |= (bgx << 16);
+
+        if (sy + height > par->crtc.vyres) {
+            wait_for_fifo(1, info);
+            aty_st_le32(SC_BOTTOM, sy + height - 1, info);
+        }
+        aty_rectfill(xoffset, sy, xres, height, bgx, info);
     }
 
 #ifdef CONFIG_FB_ATY_CT
     if (info->cursor && (yoffset + yres <= sy))
-	atyfb_cursor(p, CM_ERASE, info->cursor->pos.x, info->cursor->pos.y);
+        atyfb_cursor(p, CM_ERASE, info->cursor->pos.x, info->cursor->pos.y);
 #endif /* CONFIG_FB_ATY_CT */
 
     info->current_par.crtc.yoffset = yoffset;
@@ -2906,34 +3392,50 @@
 void cleanup_module(void)
 {
     while (fb_list) {
-	struct fb_info_aty *info = fb_list;
-	fb_list = info->next;
+        struct fb_info_aty *info = fb_list;
+        fb_list = info->next;
 
-	unregister_framebuffer(&info->fb_info);
+        unregister_framebuffer(&info->fb_info);
 
 #ifndef __sparc__
-	if (info->ati_regbase)
-	    iounmap((void *)info->ati_regbase);
-	if (info->frame_buffer)
-	    iounmap((void *)info->frame_buffer);
+        if (info->ati_regbase)
+            iounmap((void *)info->ati_regbase);
+        if (info->frame_buffer)
+            iounmap((void *)info->frame_buffer);
 #ifdef __BIG_ENDIAN
-	if (info->cursor && info->cursor->ram)
-	    iounmap(info->cursor->ram);
+        if (info->cursor && info->cursor->ram)
+            iounmap(info->cursor->ram);
 #endif
 #endif
 
-	if (info->cursor) {
-	    if (info->cursor->timer)
-		kfree(info->cursor->timer);
-	    kfree(info->cursor);
-	}
+        if (info->cursor) {
+            if (info->cursor->timer)
+                kfree(info->cursor->timer);
+            kfree(info->cursor);
+        }
 #ifdef __sparc__
-	if (info->mmap_map)
-	    kfree(info->mmap_map);
+        if (info->mmap_map)
+            kfree(info->mmap_map);
 #endif
-	kfree(info);
+        kfree(info);
     }
 }
 
 #endif
 MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Geert Uytterhoeven, Bernd Harries, Eddie C. Dost, Daniel Mantione");
+MODULE_DESCRIPTION("Accelerated FBDev driver for ATI Mach64 and derivates");
+
+MODULE_PARM(curblink, "i");
+MODULE_PARM_DESC(noblink, "Enable(1) or disable(0) cursor blinking");
+MODULE_PARM(noaccel, "i");
+MODULE_PARM_DESC(noaccel, "Disable(1) or enable(0) 2d acceleration");
+MODULE_PARM(default_vram, "i");
+MODULE_PARM_DESC(default_vram, "Specify the amount of available video memory");
+MODULE_PARM(default_pll, "i");
+MODULE_PARM_DESC(default_pll, "Specify the maximum PLL rate");
+MODULE_PARM(default_mclk, "i");
+MODULE_PARM_DESC(default_mclk, "Program the chip clock frequency (in MHz)");
+MODULE_PARM(default_xclk, "i");
+MODULE_PARM_DESC(default_xclk, "Program the memory clock frequency (in MHz)");
+
Index: drivers/video/aty/mach64.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/aty/mach64.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/aty/mach64.h	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/aty/mach64.h	4 Aug 2004 01:29:59 -0000	1.2
@@ -726,6 +726,10 @@
 #define VCLK2_POST		0x30
 #define VCLK3_POST		0xC0
 
+#define EXT_VPLL_EN		0x04
+#define EXT_VPLL_VGA_EN		0x08
+#define EXT_VPLL_INSYNC		0x10
+
 /* CONFIG_CNTL register constants */
 #define APERTURE_4M_ENABLE	1
 #define APERTURE_8M_ENABLE	2
@@ -946,6 +950,7 @@
 #define SRC_15BPP		0x300
 #define SRC_16BPP		0x400
 #define SRC_32BPP		0x600
+#define HOST_TRIPLE_EN          0x2000
 #define HOST_1BPP		0
 #define HOST_4BPP		0x10000
 #define HOST_8BPP		0x20000
@@ -1148,6 +1153,69 @@
 #define APC_LUT_MN		0x39
 #define APC_LUT_OP		0x3A
 
+/* Values in CONFIG_PANEL */
+
+#define DONT_SHADOW_HEND                0x00004000ul
+
+/* Values in LCD_GEN_CTRL */
+#define CRT_ON                          0x00000001ul
+#define LCD_ON                          0x00000002ul
+#define HORZ_DIVBY2_EN                  0x00000004ul
+#define DONT_DS_ICON                    0x00000008ul
+#define LOCK_8DOT                       0x00000010ul
+#define ICON_ENABLE                     0x00000020ul
+#define DONT_SHADOW_VPAR                0x00000040ul
+#define V2CLK_PM_EN                     0x00000080ul
+#define RST_FM                          0x00000100ul
+#define DISABLE_PCLK_RESET              0x00000200ul    /* XC/XL */
+#define DIS_HOR_CRT_DIVBY2              0x00000400ul
+#define SCLK_SEL                        0x00000800ul
+#define SCLK_DELAY                      0x0000f000ul
+#define TVCLK_PM_EN                     0x00010000ul
+#define VCLK_DAC_PM_EN                  0x00020000ul
+#define VCLK_LCD_OFF                    0x00040000ul
+#define SELECT_WAIT_4MS                 0x00080000ul
+#define XTALIN_PM_EN                    0x00080000ul    /* XC/XL */
+#define V2CLK_DAC_PM_EN                 0x00100000ul
+#define LVDS_EN                         0x00200000ul
+#define LVDS_PLL_EN                     0x00400000ul
+#define LVDS_PLL_RESET                  0x00800000ul
+#define LVDS_RESERVED_BITS              0x07000000ul
+#define CRTC_RW_SELECT                  0x08000000ul    /* LTPro */
+#define USE_SHADOWED_VEND               0x10000000ul
+#define USE_SHADOWED_ROWCUR             0x20000000ul
+#define SHADOW_EN                       0x40000000ul
+#define SHADOW_RW_EN                    0x80000000ul
+
+/* Values in HORZ_STRETCHING */
+#define HORZ_STRETCH_BLEND              0x00000ffful
+#define HORZ_STRETCH_RATIO              0x0000fffful
+#define HORZ_STRETCH_LOOP               0x00070000ul
+#define HORZ_STRETCH_LOOP09                     0x00000000ul
+#define HORZ_STRETCH_LOOP11                     0x00010000ul
+#define HORZ_STRETCH_LOOP12                     0x00020000ul
+#define HORZ_STRETCH_LOOP14                     0x00030000ul
+#define HORZ_STRETCH_LOOP15                     0x00040000ul
+/*      ?                                       0x00050000ul */
+/*      ?                                       0x00060000ul */
+/*      ?                                       0x00070000ul */
+/*      ?                               0x00080000ul */
+#define HORZ_PANEL_SIZE                 0x0ff00000ul    /* XC/XL */
+/*      ?                               0x10000000ul */
+#define AUTO_HORZ_RATIO                 0x20000000ul    /* XC/XL */
+#define HORZ_STRETCH_MODE               0x40000000ul
+#define HORZ_STRETCH_EN                 0x80000000ul
+
+/* Values in VERT_STRETCHING */
+#define VERT_STRETCH_RATIO0             0x000003fful
+#define VERT_STRETCH_RATIO1             0x000ffc00ul
+#define VERT_STRETCH_RATIO2             0x3ff00000ul
+#define VERT_STRETCH_USE0               0x40000000ul
+#define VERT_STRETCH_EN                 0x80000000ul
+
+/* Values in EXT_VERT_STRETCH */
+#define AUTO_VERT_RATIO                 0x00400000ul
+#define VERT_STRETCH_MODE		0x00000400ul
 
 /* Values in LCD_MISC_CNTL */
 #define BIAS_MOD_LEVEL_MASK	0x0000ff00
